#!/usr/bin/python
# -*- coding: utf-8 -*-

import os, sys, cgi, time, glob, string
if (int(sys.version[0])==3):
    import configparser
else:
    import ConfigParser as configparser

form = cgi.FieldStorage()
#GET HTTP PARAMETER
def getParameter( name ):
    if name in form:
        return form[name].value
    return ""

conf = configparser.RawConfigParser()
conf.read('/config/quickpost.ini')
dconf = configparser.RawConfigParser()
dconf.read('/config/quickpost_default.ini')


def getopt(cport,opt):
    retval=''
    try:
        retval=conf.get(cport,opt)
    except:
        retval=dconf.get(cport,opt)
    return retval

csvArray=glob.glob("/config/*.[cC][sS][vV]")
for i in range(len(csvArray)):
    csvArray[i] = csvArray[i][8:] #Error when doing strip("/config/")

sshKeyArray=glob.glob("/config/ssh/*")
for i in range(len(sshKeyArray)):
    sshKeyArray[i] = sshKeyArray[i][12:] #Error when doing strip("/config/ssh")

crtfArray=glob.glob("/config/ca-certificates/*.[cC][rR][tT]")
for i in range(len(crtfArray)):
    crtfArray[i] = crtfArray[i][24:] #Error when doing strip("/config/ca-certificates/")

qpversion=""
try:
    mbv=os.popen("/binary/quickpost.elf -v")
    qpversion=mbv.read()
    mbv.close()
except:
    pass

filename       = getopt('Main','FILENAME')
remote_ip      = getopt('Main','REMOTE_IP')
remote_path    = getopt('Main','REMOTE_PATH')
remote_port    = getopt('Main','REMOTE_PORT')
mbus_ascii_server_ip   = getopt('Main','MBUS_ASCII_SERVER_IP')
mbus_ascii_server_port = getopt('Main','MBUS_ASCII_SERVER_PORT')
read_timeout   = getopt('Main','READ_TIMEOUT')
n_bad_reads    = getopt('Main','N_BAD_READS')
csvfile        = getopt('Main','CSVFILE')
upload_method  = getopt('Main','UPLOAD_METHOD')
upload_time    = getopt('Main','UPLOAD_TIME')
upload_period  = getopt('Main','UPLOAD_PERIOD')
read_period    = getopt('Main','READ_PERIOD')
read_offset    = getopt('Main','READ_OFFSET')
username       = getopt('Main','USERNAME')
password       = getopt('Main','PASSWORD')
file_keep_days = getopt('Main','FILE_KEEP_DAYS')
file_format    = getopt('Main','FILE_FORMAT')
sftp_use_private_key = getopt('Main','SFTP_USE_PRIVATE_KEY')
sftp_private_key     = getopt('Main','SFTP_PRIVATE_KEY')
enable               = getopt('Main','ENABLE')
use_ssl_cert   = getopt('Main','USE_SSL_CERT')
certificate    = getopt('Main','CERTIFICATE')
startup_read_and_upload = getopt('Main','STARTUP_READ_AND_UPLOAD')

try: # This is needed to use the obsolete parameter remote_url
    remote_url = conf.get('Main','REMOTE_URL')
    r=remote_url.split('/')
    if len(r) > 2:
        remote_ip = r[2]
        remote_path = ""
    if len(r) > 3:
        remote_path = '/'.join(r[3:])
except:
    pass
#UPDATE PAGE
"""if update == "TRUE":
    print "\n<HTML>
                    <HEAD>
                        <meta http-equiv=\"refresh\" content=\"0;url=/cgi-bin/quickpost.py\">
                    </HEAD>
               </HTML>\n"
    sys.exit(0)"""

import tenjin
from tenjin.helpers import *
tenjin.Engine.cache = tenjin.MemoryCacheStorage()
engine = tenjin.Engine()
print(engine.render('templates/quickpost.pyhtml'))

